﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using HtmlToPdf_CoreSample.Models;
using Microsoft.AspNetCore.Hosting;
using Syncfusion.HtmlConverter;
using System.IO;
using Syncfusion.Pdf;
using Syncfusion.Pdf.Parsing;
using Syncfusion.Pdf.Graphics;
using Syncfusion.Drawing;

namespace HtmlToPdf_CoreSample.Controllers
{
    public class HomeController : Controller
    {
        //To get content root path of the project
        private readonly IHostingEnvironment _hostingEnvironment;
        public HomeController(IHostingEnvironment hostingEnvironment)
        {
            _hostingEnvironment = hostingEnvironment;
        }
        public IActionResult Index()
        {
            return View();
        }

        public IActionResult About()
        {
            ViewData["Message"] = "Your application description page.";

            return View();
        }

        public IActionResult Contact()
        {
            ViewData["Message"] = "Your contact page.";

            return View();
        }

        public IActionResult Privacy()
        {
            return View();
        }

        [ResponseCache(Duration = 0, Location = ResponseCacheLocation.None, NoStore = true)]
        public IActionResult Error()
        {
            return View(new ErrorViewModel { RequestId = Activity.Current?.Id ?? HttpContext.TraceIdentifier });
        }

        public IActionResult ExportToPDF()
        {
            //Initialize HTML to PDF converter 
            HtmlToPdfConverter htmlConverter = new HtmlToPdfConverter();
            WebKitConverterSettings settings = new WebKitConverterSettings();
            //Set WebKit path
            settings.WebKitPath = Path.Combine(_hostingEnvironment.ContentRootPath, "QtBinariesWindows");
            //Assign WebKit settings to HTML converter
            htmlConverter.ConverterSettings = settings;
            //Convert URL to PDF
            
            PdfDocument document = htmlConverter.Convert(Path.Combine(_hostingEnvironment.ContentRootPath, "Sample.htm"));

            //Initialize the PDF document.
            PdfDocument document1 = new PdfDocument();
            PdfPage page = null;
            PdfTemplate template = null;
            document1.PageSettings.Margins.All = 0;
            //document1 = document;
            for (int i = 0; i < document.PageCount ; i++)
            {
                template = (document.Pages[i] as PdfPage).CreateTemplate();
                if (i == (document.PageCount -1))
                {
                   
                    //Set the Orientation to Page.
                    document1.PageSettings.Orientation = PdfPageOrientation.Landscape;             
                    //Add the pages to PDF document.
                    page = document1.Pages.Add();
                    //Draw the template.
                    page.Graphics.DrawPdfTemplate(template, PointF.Empty);
                }
                else
                {
                    
                    //Set the Orientation to Page.
                    document1.PageSettings.Orientation = PdfPageOrientation.Portrait;                  
                    //Add the pages to PDF document.
                    page = document1.Pages.Add();
                    //Draw the template.               
                    page.Graphics.DrawPdfTemplate(template, PointF.Empty);
                }
            }
              
            MemoryStream ms = new MemoryStream();
            //Save the PDF document.
            document1.Save(ms);
            //Close the PDF document.
            document1.Close(true);

            return File(ms.ToArray(), System.Net.Mime.MediaTypeNames.Application.Pdf, "OrientationPDF.pdf");
        }
    }
}
